[Leetcode] 338. Counting Bits 解题报告

题目

Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1's in their binary representation and return them as an array.

Example:
For num = 5 you should return [0,1,1,2,1,2].

Follow up:

  • It is very easy to come up with a solution with run time O(n*sizeof(integer)). But can you do it in linear time O(n) /possibly in a single pass?
  • Space complexity should be O(n).
  • Can you do it like a boss? Do it without using any builtin function like __builtin_popcount in c++ or in any other language.

思路

我们经过分析就可以发现,一个数的1的个数和它的一半之间存在对应关系(可以想象一下位操作中的右移操作^_^),具体来讲:

1)如果n是偶数,那么它的二进制所含的1的个数和它的一半相同;

2)如果n是奇数,那么它的二进制所含的1的个数比它的一半对一个。

因此,一个十分简洁的状态转移方程出来了:dp[i] = dp[i / 2] + i % 2。代码的时间复杂度是O(n),空间复杂度是O(1)(我们这里没有计算返回值所占用的空间)。 

代码

class Solution {
public:
    vector<int> countBits(int num) {
        vector<int> dp(num + 1, 0);
        for (int i = 1; i <= num; ++i) {
            dp[i] = dp[i / 2] + i % 2;
        }
        return dp;
    }
};

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值